/***
   Teclas:

   ESC ---> Salir demo
     + ---> + Velocidad
     - ---> - Velocidad
     1 ---> Pixel opaco
     2 ---> Pixel AND sumado al anterior pixel an pantalla
     3 ---> Pixel OR  restado al anterior pixel an pantalla
     4 ---> Pixel XOR mezclado al anterior pixel en pantalla

   Compilacion: (Hace falta el CLIPPER 5.3 o superior)

	1.-	Clipper DEMO /n/m/w
		exospace fi DEMO Lib llibg.lib

	2.-	Clipper DEMO /n/m/w
		blinker fi DEMO Lib llibg.lib

   Esta demo esta diseada por 		Antonio Pastor Gonzalez Garcia
   en un Pentium 166 MMX con 32 Mb
   si teneis alguna sugerencia 		mail:taine@taine.com

***/

function main()

local y     :=0
local count :=0
local color :=random(255)
local speed :=1000
local modo  :=-1

   cls
   Setpos(0,0)
   set videomode to 273
   set score off
   set intensity on
   setblink( .F. )
   setcursor(0)
   caja(27.5,0,29.5,6,4,7)
   caja(27.5,6.2,29.5,9,4,7)
   caja(27.5,9.2,29.5,33,4,7)
   caja(27.5,33.2,29.5,79,4,7)
   @ 28, 1 say speed picture "@ 9999" color "n/w"
   @ 28, 7 say abs(modo) picture "@ 9" color "n/w"
   @ 28,11 say "mail:taine@taine.com" color "n/w"
   @ 28,36 say "Rutina Grafica en Clipper 5.3 by TAINE" color "r+/w"
   gsetclip(0,0,620,439)
   while .t.
       count++
       if count > 10
          if modo = -1
             limpia(speed,0)
          else
             limpia(speed,7)
          endif
          count:=0
       endif
       if linea(int(random(3))+1,color,@speed,@modo)
          exit
       endif
       gsetclip(0,400,100,480)
       @ 28, 1 say speed picture "@ 9999" color "n/w"
       @ 28, 7 say abs(modo) picture "@ 9" color "n/w"
       gsetclip(0,0,620,439)
       color:=int(random(255))
   enddo
   setcursor(1)
   set color to
   set videomode to 3
   cls
   setpos(0,0)

Return (nil)




function random(nMax)

static nSeed
local  m := 100000000
local  b := 31415621

  nSeed := iif( nSeed == nil, seconds(), nSeed )

return( nMax * ( ( nSeed := mod( nSeed*b+1, m ) ) / m ) )





function caja(nT,nL,nB,nR,nSize,nColor)

local x:=(int((nT)*16)+nSize)
local y:=(int((nL)* 8)+nSize)
local xm:=(int((nB)*16)-nSize)
local ym:=(int((nR)* 8)-nSize)

   gframe(int((nL)*8),int((nT)*16),int((nR)*8),int((nB)*16), 7,15,0, nSize,nSize,nSize,nSize, -1)
   gframe(y,x,ym,xm,nColor,nColor,nColor, 1,1,1,1,-1,.t.)

return (nil)




function lento(tecla,contador,speed,modo)

local salida:=.f.
local pi    :=1

     do case 
        case tecla=27
             contador:=50
             salida:=.t.
        case tecla=45
             speed:=speed-100
             if speed < 1
                speed:=0
             endif
        case tecla=43
             speed:=speed+100
             if speed > 5000
                speed:=5000
             endif
        case tecla=49
             modo:=-1
        case tecla=50
             modo:=-2
        case tecla=51
             modo:=-3
        case tecla=52
             modo:=-4
     endcase
     for pi:=1 to speed step 0.5
     next

return (salida)





function limpia(speed,tipo)

local count:=1
local temp1,temp2
local x:=1


     for count:=0 to 240 
        temp1:=240+count
        temp2:=240-count
        gline(0,temp2,640,temp2,tipo,-1)
        gline(0,temp1,640,temp1,tipo,-1)
        for x:=1 to speed-600 step 0.5
        next
     next

return (nil)





function linea(cual,color,speed,modo)

local count:=1
local z:=0
local pi:=0
local salir:=.f.
local tecla

     z:=random(180)
     do case
        case cual=1
           for count:=1 to 50
              tecla:=inkey()
              gline(320,240,320+(count*6),240+z+(count*2),color,modo)
              gline(320,240,320+(count*6),240-z-(count*2),color,modo)
              gline(320,240,320-(count*6),240+z+(count*2),color,modo)
              gline(320,240,320-(count*6),240-z-(count*2),color,modo)
              salir:=lento(tecla,@count,@speed,@modo)
              tecla:=0
           next
        case cual=2
           for count:=1 to 50
              tecla:=inkey()
              gline(320,240,160+(count*3.2),240+z+(count*2),color,modo)
              gline(320,240,160+(count*3.2),240-z-(count*2),color,modo)
              gline(320,240,480-(count*3.2),240+z+(count*2),color,modo)
              gline(320,240,480-(count*3.2),240-z-(count*2),color,modo)
              salir:=lento(tecla,@count,@speed,@modo)
              tecla:=0
           next
        case cual=3
           for count:=1 to 50
              tecla:=inkey()
              gline(320,240,320-(count*4),240+z+(count*2),color,modo)
              gline(320,240,320+(count*4),240-z-(count*2),color,modo)
              gline(320,240,320+(count*4),240+z+(count*2),color,modo)
              gline(320,240,320-(count*4),240-z-(count*2),color,modo)
              salir:=lento(tecla,@count,@speed,@modo)
              tecla:=0
           next
     endcase
     

return (salir)
